report 72176 ServiceItemWorksheetDCR
{
    Caption = 'Service Item Worksheet';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ServItemLine; "Service Item Line")
        {
            column(CompanyAddr1; wgCompanyAddr[1])
            {
            }
            column(CompanyAddr2; wgCompanyAddr[2])
            {
            }
            column(CompanyAddr3; wgCompanyAddr[3])
            {
            }
            column(CompanyAddr4; wgCompanyAddr[4])
            {
            }
            column(CompanyAddr5; wgCompanyAddr[5])
            {
            }
            column(CompanyAddr6; wgCompanyAddr[6])
            {
            }
            column(CompanyAddr7; wgCompanyAddr[7])
            {
            }
            column(CompanyAddr8; wgCompanyAddr[8])
            {
            }
            column(ContractNo; "Contract No.")
            {
            }
            column(CustAddr1; wgCustAddr[1])
            {
            }
            column(CustAddr2; wgCustAddr[2])
            {
            }
            column(CustAddr3; wgCustAddr[3])
            {
            }
            column(CustAddr4; wgCustAddr[4])
            {
            }
            column(CustAddr5; wgCustAddr[5])
            {
            }
            column(CustAddr6; wgCustAddr[6])
            {
            }
            column(CustAddr7; wgCustAddr[7])
            {
            }
            column(CustAddr8; wgCustAddr[8])
            {
            }
            column(Description; Description)
            {
            }
            column(DocumentNo; "Document No.")
            {
            }
            column(DocumentType; "Document Type")
            {
            }
            column(ItemNo; "Item No.")
            {
            }
            column(lblComment; Trl('Comment'))
            {
            }
            column(lblCompanyAddr; Trl('CompanyAddr'))
            {
            }
            column(lblContractNo; Trl('ContractNo'))
            {
            }
            column(lblCustAddr; Trl('CustAddr'))
            {
            }
            column(lblDate; Trl('Date'))
            {
            }
            column(lblDescription; Trl('Description'))
            {
            }
            column(lblDocumentNo; Trl('DocumentNo'))
            {
            }
            column(lblDocumentType; Trl('DocumentType'))
            {
            }
            column(lblExecutionDate; Trl('ExecutionDate'))
            {
            }
            column(lblExtraUsedItems; Trl('ExtraUsedItems'))
            {
            }
            column(lblFaultComment; Trl('FaultComment'))
            {
            }
            column(lblHours; Trl('Hours'))
            {
            }
            column(lblItemNo; Trl('ItemNo'))
            {
            }
            column(lblLocationCode; Trl('LocationCode'))
            {
            }
            column(lblNo; Trl('No'))
            {
            }
            column(lblOrderDate; Trl('OrderDate'))
            {
            }
            column(lblOrderTime; Trl('OrderTime'))
            {
            }
            column(lblPhoneNo; Trl('PhoneNo'))
            {
            }
            column(lblQuantity; Trl('Quantity'))
            {
            }
            column(lblRemarks; Trl('Remarks'))
            {
            }
            column(lblResolutionComment; Trl('ResolutionComment'))
            {
            }
            column(lblSalesPersonName; Trl('SalesPersonName'))
            {
            }
            column(lblSerialNo; Trl('SerialNo'))
            {
            }
            column(lblServiceItemGroupCode; Trl('ServiceItemGroupCode'))
            {
            }
            column(lblServiceItemNo; Trl('ServiceItemNo'))
            {
            }
            column(lblShipToAddr; Trl('ShipToAddress'))
            {
            }
            column(lblSignature; Trl('Signature'))
            {
            }
            column(lblSignName; Trl('SignName'))
            {
            }
            column(lblTravelTimeFrom; Trl('TravelTimeFrom'))
            {
            }
            column(lblTravelTimeUntil; Trl('TravelTimeUntil'))
            {
            }
            column(lblType; Trl('Type'))
            {
            }
            column(lblWarranty; Trl('Warranty'))
            {
            }
            column(lblWorkTimeFrom; Trl('WorkTimeFrom'))
            {
            }
            column(lblWorkTimeUntil; Trl('WorkTimeUntil'))
            {
            }
            column(OrderDate; wgRecServHeader."Order Date")
            {
            }
            column(OrderDateText; Format(wgRecServHeader."Order Date", 0, wgDateFormatHdr))
            {
            }
            column(OrderTime; wgRecServHeader."Order Time")
            {
            }
            column(PhoneNo; wgRecServHeader."Phone No.")
            {
            }
            column(SalesPersonName; wgRecSalesPerson.Name)
            {
            }
            column(SerialNo; "Serial No.")
            {
            }
            column(ServiceItemGroupCode; "Service Item Group Code")
            {
            }
            column(ServiceItemNo; "Service Item No.")
            {
            }
            column(ShipToAddr1; wgShipToAddr[1])
            {
            }
            column(ShipToAddr2; wgShipToAddr[2])
            {
            }
            column(ShipToAddr3; wgShipToAddr[3])
            {
            }
            column(ShipToAddr4; wgShipToAddr[4])
            {
            }
            column(ShipToAddr5; wgShipToAddr[5])
            {
            }
            column(ShipToAddr6; wgShipToAddr[6])
            {
            }
            column(ShipToAddr7; wgShipToAddr[7])
            {
            }
            column(ShipToAddr8; wgShipToAddr[8])
            {
            }
            column(TodayText; Format(Today(), 0, wgDateFormatHdr))
            {
            }
            column(Warranty; Warranty)
            {
            }
            dataitem(HdrComment; "Service Comment Line")
            {
                DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No.");
                DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(General));
                column(Comment; Comment)
                {
                }
                column(Date; Date)
                {
                }
            }
            dataitem(FaultComment; "Service Comment Line")
            {
                DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(Fault));
                column(Comment_Fault; Comment)
                {
                }
            }
            dataitem(ResolutionComment; "Service Comment Line")
            {
                DataItemLink = "Table Subtype" = field("Document Type"), "No." = field("Document No."), "Table Line No." = field("Line No.");
                DataItemTableView = sorting("Table Name", "Table Subtype", "No.", Type, "Table Line No.", "Line No.") where("Table Name" = const("Service Header"), Type = const(Resolution));
                column(Comment_Resolution; Comment)
                {
                }
            }
            dataitem(ServLine; "Service Line")
            {
                DataItemLink = "Document Type" = field("Document Type"), "Document No." = field("Document No."), "Service Item Line No." = field("Line No.");
                DataItemTableView = sorting("Document Type", "Document No.", "Service Item Line No.", Type, "No.");
                column(Description_2; Description)
                {
                }
                column(LocationCode; "Location Code")
                {
                }
                column(No; "No.")
                {
                }
                column(Quantity; Quantity)
                {
                }
                column(Type; Format(Type))
                {
                }
                column(TypeNo; Type.AsInteger())
                {
                }
                column(VendorItemNo; wgRecItem."Vendor Item No.")
                {
                }
                column(WorkTypeCode; "Work Type Code")
                {
                }
                column(WorkTypeDesc; wgRecWorkType.Description)
                {
                }

                trigger OnAfterGetRecord()
                begin
                    if (Type <> Type::Item) or (not wgRecItem.Get("No.")) then
                        Clear(wgRecItem);

                    if not wgRecWorkType.Get("Work Type Code") then
                        Clear(wgRecWorkType);
                end;
            }

            trigger OnPreDataItem()
            var
                wlCduLanguage: Codeunit Language;
            begin
                wgLanguageCode := wlCduLanguage.GetUserLanguageCode();
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode(wgLanguageCode);
            end;

            trigger OnAfterGetRecord()
            begin
                wgRecServHeader.Get("Document Type", "Document No.");

                Clear(wgRecSalesPerson);
                if wgRecServHeader."Salesperson Code" <> '' then
                    wgRecSalesPerson.Get(wgRecServHeader."Salesperson Code");

                wgCduFormatAddr.ServiceOrderShipto(wgShipToAddr, wgRecServHeader);
                wgShipToAddr[8] := wgRecServHeader."Ship-to Phone";
                CompressArray(wgShipToAddr);

                if wgRecRespCenter.Get(wgRecServHeader."Responsibility Center") then begin
                    wgCduFormatAddr.RespCenter(wgCompanyAddr, wgRecRespCenter);
                    wgRecCompanyInfo."Phone No." := wgRecRespCenter."Phone No.";
                    wgRecCompanyInfo."Fax No." := wgRecRespCenter."Fax No.";
                end else
                    wgCduFormatAddr.Company(wgCompanyAddr, wgRecCompanyInfo);

                wgCduFormatAddr.ServiceOrderSellto(wgCustAddr, wgRecServHeader);
            end;
        }
    }

    trigger OnPreReport()
    begin
        wlFncInitReportSettings();
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecItem: Record Item;
        wgRecRespCenter: Record "Responsibility Center";
        wgRecSalesPerson: Record "Salesperson/Purchaser";
        wgRecServHeader: Record "Service Header";
        wgRecWorkType: Record "Work Type";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgLanguageCode: Code[10];
        wgDateFormatHdr: Integer;
        wgReportId: Integer;
        wgCompanyAddr: array[8] of Text[100];
        wgCustAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];


    local procedure Trl(pLblName: Text[50]): Text
    begin
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    local procedure wlFncInitReportSettings()
    var
        wlCduTemplateReportHelperDCR: Codeunit TemplateReportHelperDCR;
    begin
        if wgReportId = 0 then
            Evaluate(wgReportId, (DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890'))));
        wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        wgDateFormatHdr := wlCduTemplateReportHelperDCR.wgFncGetHeaderDateFormat(wgReportId);
    end;
}
