codeunit 72100 TemplateReportHelperDCR
{
    Access = Public;

    /// <summary>
    /// Retrieves the format-option that should be used to format dates from the document header of a report.
    /// </summary>
    /// <param name="pReportID">The ID of the report.</param>
    /// <returns>The Format to use.</returns>
    procedure wgFncGetHeaderDateFormat(pReportID: Integer) wlDateFormat: Integer
    begin
        wlDateFormat := 4;
        wlEvpOnAfterGetHeaderDateFormat(pReportID, wlDateFormat);
    end;

    [IntegrationEvent(false, false)]
    local procedure wlEvpOnAfterGetHeaderDateFormat(pReportID: Integer; var vDateFormat: Integer)
    begin
    end;
}
